(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tslib'), require('@angular/core'), require('@angular/common'), require('@angular/elements'), require('@angular/platform-browser'), require('rxjs/observable/fromPromise'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('iwe7-elements', ['exports', 'tslib', '@angular/core', '@angular/common', '@angular/elements', '@angular/platform-browser', 'rxjs/observable/fromPromise', 'rxjs'], factory) :
    (factory((global['iwe7-elements'] = {}),global.tslib,global.ng.core,global.ng.common,global.ng.elements,global.ng.platformBrowser,global.Rx.Observable,global.rxjs));
}(this, (function (exports,tslib,core,common,elements,platformBrowser,fromPromise,rxjs) { 'use strict';

    platformBrowser.ɵinitDomAdapter();
    var ElementInjector = (function () {
        function ElementInjector() {
        }
        /**
         * @param {?} token
         * @param {?=} notFoundValue
         * @return {?}
         */
        ElementInjector.prototype.get = function (token, notFoundValue) {
            switch (token) {
                case core.PLATFORM_ID:
                    return common.ɵPLATFORM_BROWSER_ID;
                case common.PlatformLocation:
                    return new platformBrowser.ɵBrowserPlatformLocation(this.get(common.DOCUMENT));
                case core.NgZone:
                    return new core.NgZone({
                        enableLongStackTrace: false
                    });
                case core.Compiler:
                    return new core.Compiler();
                case common.DOCUMENT:
                    return document;
                default:
                    return notFoundValue;
            }
        };
        return ElementInjector;
    }());
    var /** @type {?} */ elementInjector = new ElementInjector();
    /**
     * @param {?} appModuleFactory
     * @param {?=} moduleFactory
     * @param {?=} parentInjector
     * @return {?}
     */
    function createAotElements(appModuleFactory, moduleFactory, parentInjector) {
        // 主
        parentInjector = parentInjector || elementInjector;
        var /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
        var /** @type {?} */ moduleRef;
        var /** @type {?} */ moduleType;
        if (moduleFactory) {
            moduleRef = moduleFactory.create(appModuleRef.injector);
            moduleType = moduleFactory.moduleType;
        }
        else {
            moduleRef = appModuleRef;
            moduleType = appModuleFactory.moduleType;
        }
        // 子
        var /** @type {?} */ componentFactoryResolver = moduleRef.componentFactoryResolver;
        var /** @type {?} */ decorators = ((moduleType)).decorators;
        var /** @type {?} */ obsers = [];
        decorators.map(function (res) {
            var /** @type {?} */ args = res.args;
            args.map(function (arg) {
                var /** @type {?} */ entryComponents = arg.entryComponents;
                if (entryComponents) {
                    entryComponents.map(function (res) {
                        var /** @type {?} */ componentFactory = componentFactoryResolver.resolveComponentFactory(res);
                        var /** @type {?} */ cus = elements.createCustomElement(componentFactory.componentType, {
                            injector: moduleRef.injector
                        });
                        customElements.define(componentFactory.selector, cus);
                        ((window)).ElementsMap.set(componentFactory.selector, cus);
                        obsers.push(fromPromise.fromPromise(customElements
                            .whenDefined(componentFactory.selector)
                            .then(function (res) {
                            return componentFactory.selector;
                        })));
                    });
                }
            });
        });
        ((window)).ElementsLoad = rxjs.forkJoin.apply(void 0, tslib.__spread(obsers));
    }
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    ((window)).ElementsLoad = ((window)).ElementsLoad || rxjs.of(null);
    ((window)).ElementsMap = ((window)).ElementsMap || new Map();
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var /** @type {?} */ ElementMedataKey = "__element_medata_key__";
    /**
     * @param {?} selector
     * @return {?}
     */
    function Element(selector) {
        return function (target, propName) {
            return setElement(target, {
                propName: propName,
                selector: selector
            });
        };
    }
    /**
     * @param {?} type
     * @param {?} metadata
     * @return {?}
     */
    function setElement(type, metadata) {
        var selector = metadata.selector;
        var /** @type {?} */ element$ = new rxjs.Observable(function (observer) {
            setTimeout(function () {
                ElementsLoad.subscribe(function (res) {
                    observer.next(selector);
                    observer.complete();
                });
            }, 0);
        });
        type[metadata.propName] = element$;
    }

    exports.ElementInjector = ElementInjector;
    exports.elementInjector = elementInjector;
    exports.createAotElements = createAotElements;
    exports.ElementMedataKey = ElementMedataKey;
    exports.Element = Element;
    exports.setElement = setElement;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=iwe7-elements.umd.js.map
