/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { NgZone, PLATFORM_ID, Compiler } from "@angular/core";
import { ɵPLATFORM_BROWSER_ID as PLATFORM_BROWSER_ID } from "@angular/common";
import { DOCUMENT, PlatformLocation } from "@angular/common";
import { createCustomElement } from "@angular/elements";
import { ɵBrowserPlatformLocation as BrowserPlatformLocation, ɵinitDomAdapter as initDomAdapter } from "@angular/platform-browser";
import { fromPromise } from "rxjs/observable/fromPromise";
import { forkJoin } from "rxjs";
initDomAdapter();
export class ElementInjector {
    /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @return {?}
     */
    get(token, notFoundValue) {
        switch (token) {
            case PLATFORM_ID:
                return PLATFORM_BROWSER_ID;
            case PlatformLocation:
                return new BrowserPlatformLocation(this.get(DOCUMENT));
            case NgZone:
                return new NgZone({
                    enableLongStackTrace: false
                });
            case Compiler:
                return new Compiler();
            case DOCUMENT:
                return document;
            default:
                return notFoundValue;
        }
    }
}
export const /** @type {?} */ elementInjector = new ElementInjector();
/**
 * @param {?} appModuleFactory
 * @param {?=} moduleFactory
 * @param {?=} parentInjector
 * @return {?}
 */
export function createAotElements(appModuleFactory, moduleFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    let /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    let /** @type {?} */ moduleRef;
    let /** @type {?} */ moduleType;
    if (moduleFactory) {
        moduleRef = moduleFactory.create(appModuleRef.injector);
        moduleType = moduleFactory.moduleType;
    }
    else {
        moduleRef = appModuleRef;
        moduleType = appModuleFactory.moduleType;
    }
    // 子
    let /** @type {?} */ componentFactoryResolver = moduleRef.componentFactoryResolver;
    let /** @type {?} */ decorators = (/** @type {?} */ (moduleType)).decorators;
    let /** @type {?} */ obsers = [];
    decorators.map((res) => {
        let /** @type {?} */ args = res.args;
        args.map((arg) => {
            let /** @type {?} */ entryComponents = arg.entryComponents;
            if (entryComponents) {
                entryComponents.map((res) => {
                    let /** @type {?} */ componentFactory = componentFactoryResolver.resolveComponentFactory(res);
                    const /** @type {?} */ cus = createCustomElement(componentFactory.componentType, {
                        injector: moduleRef.injector
                    });
                    customElements.define(componentFactory.selector, cus);
                    (/** @type {?} */ (window)).ElementsMap.set(componentFactory.selector, cus);
                    obsers.push(fromPromise(customElements
                        .whenDefined(componentFactory.selector)
                        .then((res) => {
                        return componentFactory.selector;
                    })));
                });
            }
        });
    });
    (/** @type {?} */ (window)).ElementsLoad = forkJoin(...obsers);
}
//# sourceMappingURL=injector.js.map
