import { NgZone, PLATFORM_ID, Compiler } from '@angular/core';
import { ɵPLATFORM_BROWSER_ID, DOCUMENT, PlatformLocation } from '@angular/common';
import { createCustomElement } from '@angular/elements';
import { ɵBrowserPlatformLocation, ɵinitDomAdapter } from '@angular/platform-browser';
import { fromPromise } from 'rxjs/observable/fromPromise';
import { forkJoin, of, Observable } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
ɵinitDomAdapter();
class ElementInjector {
    /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @return {?}
     */
    get(token, notFoundValue) {
        switch (token) {
            case PLATFORM_ID:
                return ɵPLATFORM_BROWSER_ID;
            case PlatformLocation:
                return new ɵBrowserPlatformLocation(this.get(DOCUMENT));
            case NgZone:
                return new NgZone({
                    enableLongStackTrace: false
                });
            case Compiler:
                return new Compiler();
            case DOCUMENT:
                return document;
            default:
                return notFoundValue;
        }
    }
}
const /** @type {?} */ elementInjector = new ElementInjector();
/**
 * @param {?} appModuleFactory
 * @param {?=} moduleFactory
 * @param {?=} parentInjector
 * @return {?}
 */
function createAotElements(appModuleFactory, moduleFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    let /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    let /** @type {?} */ moduleRef;
    let /** @type {?} */ moduleType;
    if (moduleFactory) {
        moduleRef = moduleFactory.create(appModuleRef.injector);
        moduleType = moduleFactory.moduleType;
    }
    else {
        moduleRef = appModuleRef;
        moduleType = appModuleFactory.moduleType;
    }
    // 子
    let /** @type {?} */ componentFactoryResolver = moduleRef.componentFactoryResolver;
    let /** @type {?} */ decorators = (/** @type {?} */ (moduleType)).decorators;
    let /** @type {?} */ obsers = [];
    decorators.map((res) => {
        let /** @type {?} */ args = res.args;
        args.map((arg) => {
            let /** @type {?} */ entryComponents = arg.entryComponents;
            if (entryComponents) {
                entryComponents.map((res) => {
                    let /** @type {?} */ componentFactory = componentFactoryResolver.resolveComponentFactory(res);
                    const /** @type {?} */ cus = createCustomElement(componentFactory.componentType, {
                        injector: moduleRef.injector
                    });
                    customElements.define(componentFactory.selector, cus);
                    (/** @type {?} */ (window)).ElementsMap.set(componentFactory.selector, cus);
                    obsers.push(fromPromise(customElements
                        .whenDefined(componentFactory.selector)
                        .then((res) => {
                        return componentFactory.selector;
                    })));
                });
            }
        });
    });
    (/** @type {?} */ (window)).ElementsLoad = forkJoin(...obsers);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
(/** @type {?} */ (window)).ElementsLoad = (/** @type {?} */ (window)).ElementsLoad || of(null);
(/** @type {?} */ (window)).ElementsMap = (/** @type {?} */ (window)).ElementsMap || new Map();

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
const /** @type {?} */ ElementMedataKey = "__element_medata_key__";
/**
 * @param {?} selector
 * @return {?}
 */
function Element(selector) {
    return (target, propName) => {
        return setElement(target, {
            propName,
            selector
        });
    };
}
/**
 * @param {?} type
 * @param {?} metadata
 * @return {?}
 */
function setElement(type, metadata) {
    let { selector } = metadata;
    let /** @type {?} */ element$ = new Observable((observer) => {
        setTimeout(() => {
            ElementsLoad.subscribe(res => {
                observer.next(selector);
                observer.complete();
            });
        }, 0);
    });
    type[metadata.propName] = element$;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { ElementInjector, elementInjector, createAotElements, ElementMedataKey, Element, setElement };
//# sourceMappingURL=iwe7-elements.js.map
