import { __spread } from 'tslib';
import { NgZone, PLATFORM_ID, Compiler } from '@angular/core';
import { ɵPLATFORM_BROWSER_ID, DOCUMENT, PlatformLocation } from '@angular/common';
import { createCustomElement } from '@angular/elements';
import { ɵBrowserPlatformLocation, ɵinitDomAdapter } from '@angular/platform-browser';
import { fromPromise } from 'rxjs/observable/fromPromise';
import { forkJoin, of, Observable } from 'rxjs';

ɵinitDomAdapter();
var ElementInjector = /** @class */ (function () {
    function ElementInjector() {
    }
    /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @return {?}
     */
    ElementInjector.prototype.get = function (token, notFoundValue) {
        switch (token) {
            case PLATFORM_ID:
                return ɵPLATFORM_BROWSER_ID;
            case PlatformLocation:
                return new ɵBrowserPlatformLocation(this.get(DOCUMENT));
            case NgZone:
                return new NgZone({
                    enableLongStackTrace: false
                });
            case Compiler:
                return new Compiler();
            case DOCUMENT:
                return document;
            default:
                return notFoundValue;
        }
    };
    return ElementInjector;
}());
var /** @type {?} */ elementInjector = new ElementInjector();
/**
 * @param {?} appModuleFactory
 * @param {?=} moduleFactory
 * @param {?=} parentInjector
 * @return {?}
 */
function createAotElements(appModuleFactory, moduleFactory, parentInjector) {
    // 主
    parentInjector = parentInjector || elementInjector;
    var /** @type {?} */ appModuleRef = appModuleFactory.create(parentInjector);
    var /** @type {?} */ moduleRef;
    var /** @type {?} */ moduleType;
    if (moduleFactory) {
        moduleRef = moduleFactory.create(appModuleRef.injector);
        moduleType = moduleFactory.moduleType;
    }
    else {
        moduleRef = appModuleRef;
        moduleType = appModuleFactory.moduleType;
    }
    // 子
    var /** @type {?} */ componentFactoryResolver = moduleRef.componentFactoryResolver;
    var /** @type {?} */ decorators = ((moduleType)).decorators;
    var /** @type {?} */ obsers = [];
    decorators.map(function (res) {
        var /** @type {?} */ args = res.args;
        args.map(function (arg) {
            var /** @type {?} */ entryComponents = arg.entryComponents;
            if (entryComponents) {
                entryComponents.map(function (res) {
                    var /** @type {?} */ componentFactory = componentFactoryResolver.resolveComponentFactory(res);
                    var /** @type {?} */ cus = createCustomElement(componentFactory.componentType, {
                        injector: moduleRef.injector
                    });
                    customElements.define(componentFactory.selector, cus);
                    ((window)).ElementsMap.set(componentFactory.selector, cus);
                    obsers.push(fromPromise(customElements
                        .whenDefined(componentFactory.selector)
                        .then(function (res) {
                        return componentFactory.selector;
                    })));
                });
            }
        });
    });
    ((window)).ElementsLoad = forkJoin.apply(void 0, __spread(obsers));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
((window)).ElementsLoad = ((window)).ElementsLoad || of(null);
((window)).ElementsMap = ((window)).ElementsMap || new Map();

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var /** @type {?} */ ElementMedataKey = "__element_medata_key__";
/**
 * @param {?} selector
 * @return {?}
 */
function Element(selector) {
    return function (target, propName) {
        return setElement(target, {
            propName: propName,
            selector: selector
        });
    };
}
/**
 * @param {?} type
 * @param {?} metadata
 * @return {?}
 */
function setElement(type, metadata) {
    var selector = metadata.selector;
    var /** @type {?} */ element$ = new Observable(function (observer) {
        setTimeout(function () {
            ElementsLoad.subscribe(function (res) {
                observer.next(selector);
                observer.complete();
            });
        }, 0);
    });
    type[metadata.propName] = element$;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { ElementInjector, elementInjector, createAotElements, ElementMedataKey, Element, setElement };
//# sourceMappingURL=iwe7-elements.js.map
